﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using ThinkGeo.MapSuite.WpfDesktopEdition;
using ThinkGeo.MapSuite.Core;

namespace LearnWPF
{
	/// <summary>
	/// Interaction logic for WpfMAp.xaml
	/// </summary>
	public partial class WpfMAp : Window
	{		
		public WpfMAp()
		{
			InitializeComponent();
			this.Loaded += new RoutedEventHandler(WpfMAp_Loaded);
		}

		void WpfMAp_Loaded(object sender, RoutedEventArgs e)
		{
			LoadMap();
		}

		private void LoadMap()
		{
			GdiPlusRasterLayer rootLayer = new GdiPlusRasterLayer("root.jpg");
			LayerOverlay ovrlay = new LayerOverlay();
			
			ovrlay.Layers.Add(rootLayer);
			rootLayer.Open();			
			wpfMap.Height = 800;
			wpfMap.Width = 1000;
			wpfMap.CurrentExtent = rootLayer.GetBoundingBox();
			rootLayer.Close();

			wpfMap.MapTools.Logo.IsEnabled = false;
			ovrlay.TransitionEffect = TransitionEffect.None;

			wpfMap.Overlays.Add("root", ovrlay);
			//DrawObjct();
			
		}	

		private void DrawObjct()
		{

			InMemoryFeatureLayer objectFeaturelayer = new InMemoryFeatureLayer();
			objectFeaturelayer.Open();
			objectFeaturelayer.Columns.Add(new FeatureSourceColumn("Type"));
			objectFeaturelayer.Columns.Add(new FeatureSourceColumn("Id"));
			objectFeaturelayer.Columns.Add(new FeatureSourceColumn("Index"));

			objectFeaturelayer.Close();

			ValueStyle valueStyle = new ValueStyle();
			valueStyle.ColumnName = "Id";

			objectFeaturelayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle.IsActive = false;
			objectFeaturelayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle.IsActive = false;
			objectFeaturelayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.IsActive = false;

			

			for (int i = 0; i < 20; i++)
			{
				Random rand = new Random(i);
				PointShape pointShape = new PointShape(-122.5 + rand.NextDouble(), 36.5 + rand.NextDouble());

				Feature objectFeature = new Feature(pointShape);

				objectFeature.ColumnValues.Add("Type", i.ToString());
				objectFeature.ColumnValues.Add("Id", i.ToString());
				objectFeature.ColumnValues.Add("Index", i.ToString());
				PointStyle objectPointStyle = new PointStyle(new GeoImage(System.IO.Path.GetFullPath("Pin.png")));
				objectPointStyle.PointType = PointType.Bitmap;

				valueStyle.ValueItems.Add(new ValueItem(i.ToString(), objectPointStyle));
				objectFeaturelayer.InternalFeatures.Add(objectFeature);
			}


			objectFeaturelayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(valueStyle);
			objectFeaturelayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;		

			LayerOverlay deviceOverlay = new LayerOverlay();

			deviceOverlay.TransitionEffect = TransitionEffect.None;

			deviceOverlay.Layers.Add("ObjectsLayer", objectFeaturelayer);

			wpfMap.Overlays.Add("Objects", deviceOverlay);
		}

		private void btnMapClick_Click(object sender, RoutedEventArgs e)
		{
			DrawObjct();
			wpfMap.Refresh(wpfMap.Overlays["Objects"]);
		}
	}
}
